Crowd_Funding_System/urls.py
from django.contrib import admin
from django.urls import path, include
from django.conf import settings
from django.conf.urls.static import static

urlpatterns = [
    path('accounts/', include('apps.accounts.urls')),
    path('admin/', include('apps.admin_dashboard.urls')),
    path('projects/', include('apps.projects.urls')),
    path('categories/', include('apps.categories.urls')),
    path('', include('apps.homepage.urls')),
] + static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

apps/accounts/urls.py
from django.urls import path
from . import views

urlpatterns = [
    path('register/', views.create_user, name='accounts_register'),
    path('login_/', views.login_user, name='login_'),
    path('logout/', views.logout_user, name='logout'),
    path('activate/<uidb64>/<token>', views.activate, name='accounts_activate'),
    path('delete_account/', views.delete_account, name='delete_account'),
    path("profile/<int:id>", views.user_profile, name="profile"),
    path('edit-profile/', views.edit_profile, name='edit_profile'),
    path("change_password/", views.change_password, name="change_password"),
    path("reset_password", views.password_reset_request, name="reset_password"),
    path('reset/<uidb64>/<token>', views.password_reset_confirm, name='password_reset_confirm'),
]

apps/accounts/models.py
from django.db import models
from django.contrib.auth.models import User
from django.core.validators import RegexValidator
from django_countries.fields import CountryField


class CustomUser(User):
    phone_number = models.CharField(max_length=11, validators=[RegexValidator(regex='^01[0125]{1}[0-9]{8}$', message='Enter a valid Egyptian phone number.')], unique=True)
    profile_picture = models.ImageField(upload_to='user_uploads/', null=True, blank=True, default='user_uploads/default_profile_picture.jpg')
    facebook_profile = models.URLField(max_length=200, blank=True, null=True)
    birth_date = models.DateField(null=True, blank=True)
    country = CountryField(blank_label='Select a country', null=True, blank=True)

    def __str__(self):
        return f"{self.first_name} {self.last_name}"

    @property
    def profile_picture_url(self):
        return f'/media/{self.profile_picture}'

apps/accounts/forms.py
import re
from datetime import date
from django.contrib.auth.forms import UserCreationForm, PasswordResetForm, SetPasswordForm
from django.core.exceptions import ValidationError
from django.contrib.auth import get_user_model
from django import forms
from django_countries.fields import CountryField

from .models import CustomUser

User = get_user_model()


class RegistrationForm(UserCreationForm):
    username = forms.EmailField(widget=forms.EmailInput(attrs={
        "class": "form-control",
        "placeholder": "Enter your email"
    }))

    first_name = forms.CharField(widget=forms.TextInput(attrs={
        "class": "form-control",
        "type": "text",
        "placeholder": "Enter First Name"
    }))

    last_name = forms.CharField(widget=forms.TextInput(attrs={
        "class": "form-control",
        "type": "text",
        "placeholder": "Enter Last Name"
    }))

    password1 = forms.CharField(widget=forms.PasswordInput(attrs={
        "class": "form-control",
        "type": "password",
        "placeholder": "Enter Password"
    }))

    password2 = forms.CharField(widget=forms.PasswordInput(attrs={
        "class": "form-control",
        "type": "password",
        "placeholder": "Re-enter Password"
    }))

    phone_number = forms.CharField(widget=forms.TextInput(attrs={
        "class": "form-control",
        "type": "text",
        "placeholder": "Enter Phone Number",
    }))

    profile_picture = forms.ImageField(widget=forms.FileInput(attrs={
        "class": "form-control",
        "type": "file"
    }), required=False)

    class Meta(UserCreationForm.Meta):
        model = CustomUser
        fields = ['username', 'first_name', 'last_name', 'password1', 'password2', 'phone_number', 'profile_picture']

    def clean_first_name(self):
        first_name = self.cleaned_data.get('first_name')
        if len(first_name) < 2:
            raise ValidationError('First name is too short')
        return first_name

    def clean_last_name(self):
        last_name = self.cleaned_data.get('last_name')
        if len(last_name) < 2:
            raise ValidationError('Last name is too short')
        return last_name

    def clean_username(self):
        username = self.cleaned_data.get('username')
        errors = []

        if User.objects.filter(username=username).exists():
            errors.append("This email is already taken. Please choose a different one.")

        elif not re.match(r'^[\w.+-]+@[\w.-]+\.[a-zA-Z]{2,}$', username):
            errors.append("Please enter a valid email address.")

        if errors:
            self.add_error('username', errors)

        return username


class LoginForm(forms.Form):
    username = forms.EmailField(widget=forms.EmailInput(attrs={
        "class": "form-control",
        "placeholder": "Enter your email"
    }))

    password = forms.CharField(widget=forms.PasswordInput(attrs={
        "class": "form-control",
        "placeholder": "Enter your password"
    }))

    def clean_username(self):
        username = self.cleaned_data.get('username')
        errors = []

        if not re.match(r'^[\w.+-]+@[\w.-]+\.[a-zA-Z]{2,}$', username):
            errors.append("Please enter a valid email address.")

        if errors:
            self.add_error('username', errors)

        return username


def validate_facebook_url(value):
    # regex to match Facebook URLs
    regex = r'^https?://(www\.)?facebook\.com/.+'

    if value and not re.match(regex, value):
        return False
    return True


class EditProfileForm(forms.ModelForm):
    class Meta:
        model = CustomUser
        fields = ['first_name', 'last_name', 'phone_number', 'profile_picture', 'facebook_profile', 'birth_date']
        widgets = {
            'first_name': forms.TextInput(attrs={'class': 'form-control', 'placeholder': 'Enter First Name'}),
            'last_name': forms.TextInput(attrs={'class': 'form-control', 'placeholder': 'Enter Last Name'}),
            'phone_number': forms.TextInput(attrs={'class': 'form-control', 'placeholder': 'Enter Phone Number'}),
            'profile_picture': forms.FileInput(attrs={'class': 'form-control'}),
            'facebook_profile': forms.URLInput(attrs={'class': 'form-control', 'placeholder': 'Enter Facebook Profile URL'}),
            'birth_date': forms.DateInput(attrs={'class': 'form-control', 'type': 'date'}),
        }

    def clean_mobile_phone(self):
        phone_number = self.cleaned_data.get('phone_number')
        if phone_number and not re.match(r'^01[0125]{1}[0-9]{8}$', phone_number):
            raise forms.ValidationError("Mobile phone number must be a valid Egyptian phone number.")
        return phone_number

    def clean_first_name(self):
        first_name = self.cleaned_data.get('first_name')
        if len(first_name) < 2:
            raise forms.ValidationError("First name must be at least 2 characters long.")
        return first_name

    def clean_last_name(self):
        last_name = self.cleaned_data.get('last_name')
        if len(last_name) < 2:
            raise forms.ValidationError("Last name must be at least 2 characters long.")
        return last_name

    def clean_profile_picture(self):
        profile_picture = self.cleaned_data.get('profile_picture')
        if not profile_picture:
            return 'user_uploads/default_profile_picture.jpg'
        return profile_picture

    def clean_birth_date(self):
        birth_date = self.cleaned_data.get('birth_date')
        if birth_date:
            today = date.today()
            # check if birthdate is after today's date
            if birth_date > today:
                raise forms.ValidationError("Birthdate cannot be in the future.")
        return birth_date

    def clean_facebook_profile(self):
        facebook_profile = self.cleaned_data.get('facebook_profile')
        if facebook_profile:
            if not validate_facebook_url(facebook_profile):
                raise ValidationError('Invalid Facebook URL')
        return facebook_profile


class ChangePasswordForm(SetPasswordForm):
    class Meta:
        model = get_user_model()
        fields = ['new_password1', 'new_password2']

    new_password1 = forms.CharField(widget=forms.PasswordInput(attrs={
        "class": "form-control",
        "type": "password",
        "placeholder": "Enter Password"
    }))

    new_password2 = forms.CharField(widget=forms.PasswordInput(attrs={
        "class": "form-control",
        "type": "password",
        "placeholder": "Re-enter Password"
    }))


class ResetPasswordForm(PasswordResetForm):
    username = forms.EmailField(widget=forms.EmailInput(attrs={
        "class": "form-control",
        "type": "email",
    }))

    def __init__(self, *args, **kwargs):
        super(ResetPasswordForm, self).__init__(*args, **kwargs)
        self.cleaned_data = None
        self.fields['username'] = self.fields['email']
        del self.fields['email']

    def clean_username(self):
        email = self.cleaned_data['username']

        if not email:
            raise ValidationError("Email field is required.")

        return email

apps/accounts/templates/profile/edit_profile.html
{% extends 'layouts/base.html' %}

{% load static %}

{% block navbar %}

{% include 'layouts/navbar.html' %}

{% endblock%}

{% block content %}

<section>
    <div>
        <div class="container">
            <div class="row">
                <div class="col-12 col-md-8 col-lg-8 mx-md-auto">
                    <form action="." class="p-3 m-5 rounded glass" enctype="multipart/form-data" method="POST">
                        {% csrf_token %}
                        <h1 class="">Edit Profile</h1>

                        <!-- Start first_name -->
                        <div class="my-4">
                            <label class="form-label" for="id_first_name">First Name</label>
                            <div class="input-group has-validation">
                                {{ form.first_name }}
                            </div>
                            {% for error in form.first_name.errors %}
                            <div class="invalid-feedback d-block">{{ error }}</div>
                            {% endfor %}
                        </div>
                        <!-- End first_name  -->

                        <!-- Start last_name -->
                        <div class="my-4">
                            <label class="form-label" for="id_last_name">Last Name</label>
                            <div class="input-group has-validation">
                                {{ form.last_name }}
                            </div>
                            {% for error in form.last_name.errors %}
                            <div class="invalid-feedback d-block">{{ error }}</div>
                            {% endfor %}
                        </div>
                        <!-- End last_name  -->

                        <!-- Start phone_number  -->
                        <div class="my-4">
                            <label class="form-label" for="id_phone_number">Phone Number</label>
                            <div class="input-group has-validation">
                                {{ form.phone_number }}
                            </div>
                            {% for error in form.phone_number.errors %}
                            <div class="invalid-feedback d-block">{{ error }}</div>
                            {% endfor %}
                        </div>
                        <!-- End phone_number  -->

                        <!-- Start facebook_profile  -->
                        <div class="my-4">
                            <label class="form-label" for="id_facebook_profile">Facebook Profile</label>
                            <div class="input-group has-validation">
                                {{ form.facebook_profile }}
                            </div>
                            {% for error in form.facebook_profile.errors %}
                            <div class="invalid-feedback d-block">{{ error }}</div>
                            {% endfor %}
                        </div>
                        <!-- End facebook_profile  -->

                        <!-- start end_time -->
                        <div class="my-4">
                            <label class="form-label" for="id_birth_date">Birth Date</label>
                            <div class="input-group has-validation">
                                {{ form.birth_date }}
                            </div>
                            {% for error in form.birth_date.errors %}
                            <div class="invalid-feedback d-block">{{ error }}</div>
                            {% endfor %}
                        </div>
                        <!-- End end_time -->

                        <!-- Start country -->
                        {% load countries %}
                        {% get_countries as countries %}
                        <div class="my-4">
                            <label class="form-label" for="id_country">Country</label>
                            <div class="input-group has-validation">
                                <select class="form-select" id="id_country" name="country">
                                    <!-- Corrected name attribute -->
                                    <option disabled selected value="">Select a country</option>
                                    {% for country in countries %}
                                    <option value="{{ country.code }}">{{ country.name }}</option>
                                    {% endfor %}
                                </select>
                            </div>
                            {% for error in form.country.errors %}
                            <div class="invalid-feedback d-block">{{ error }}</div>
                            {% endfor %}
                        </div>
                        <!-- End country -->

                        <!-- End profile_picture  -->
                        <div class="my-4">
                            <label class="form-label" for="id_profile_picture">Profile Picture</label>
                            <div class="input-group has-validation">
                                {{ form.profile_picture }}
                            </div>
                            {% for error in form.profile_picture.errors %}
                            <div class="invalid-feedback d-block">{{ error }}</div>
                            {% endfor %}
                        </div>
                        <!-- End profile_picture  -->
                        <div class="row">
                            <div class="col">
                                <button class="btn btn-primary" type="submit">Save Changes</button>
                                <a href="{% url 'profile' user.id %}" class="btn btn-secondary">Cancel</a>
                            </div>

                            <div class="col text-end">
                                <a href="{% url 'change_password' %}" class="btn btn-info">Change password</a>
                                <button class="btn btn-danger" data-bs-target="#deleteModal" data-bs-toggle="modal"
                                        type="button">Delete Account
                                </button>
                            </div>
                        </div>

                    </form>
                    <!-- Delete Account Modal -->
                    <div aria-hidden="true" aria-labelledby="deleteModalLabel" class="modal fade" id="deleteModal" tabindex="-1" data-bs-backdrop="static">
                        <div class="modal-dialog modal-dialog-centered">
                            <div class="modal-content">
                                <div class="modal-header">
                                    <h5 class="modal-title" id="deleteModalLabel">Confirm Account Deletion</h5>
                                    <button aria-label="Close" class="btn-close" data-bs-dismiss="modal" type="button"></button>
                                </div>
                                <div class="modal-body">
                                    <p>Are you sure you want to delete your account?</p>
                                    <p>To confirm deletion, please type <strong>Delete</strong> in the input field below:</p>
                                    <form action="{% url 'delete_account' %}" method="post">
                                        {% csrf_token %}
                                        <div class="mb-3">
                                                <input class="form-control" id="confirmationInput" name="confirmation" required type="text">
                                        </div>
                                        <button class="btn btn-danger" type="submit">Confirm Delete</button>
                                    </form>
                                </div>
                            </div>
                        </div>
                    </div>


                </div>
            </div>
        </div>
    </div>
</section>

{% endblock %}

{%block scripts %}

<script src="{% static 'accounts/js/script.js' %}"></script>

<script>
    const phoneNumberInput = document.querySelector('#id_phone_number');
    phoneNumberInput.removeAttribute('required');
</script>
{% endblock %}

apps/accounts/templates/profile/profile_page.html
{% extends 'layouts/base.html' %}
{% load static %}


<head>
    {% block title %} profile {%endblock %}

    {% block styles %}
    <!-- Owl carousel css -->
    <link href="{% static 'accounts/css/owl.carousel.min.css' %}" rel="stylesheet">
    <link href="{% static 'accounts/css/owl.theme.default.min.css' %}" rel="stylesheet">
    <link href="{% static 'accounts/css/styles.css' %}" rel="stylesheet">

    {% endblock %}

</head>

{% block navbar %}

{% include 'layouts/navbar.html' %}

{% endblock%}

{% block content %}
<div class="container">
{% if messages %}
<div class="my-4 mx-auto alert alert-success col-md-4 text-center fs-5" id="success-message">
    {% for message in messages %}
    <p class="mt-1">{{ message }}</p>
    {% endfor %}
</div>
{% endif %}

<!-- User Data -->
<section class="py-5">
    <div class="row align-items-center">
        <div class="col-12 col-md-5">
            <div class="card py-2 text-center">
                <img class="card-img-top rounded-circle w-50 m-auto" src="{{User.profile_picture_url}}"/>
                <div class="card-title">
                    <h3 class="my-3">{{User}}</h3>

                    <a class="btn text-light" style="background-color:#13ADB7;" href="{% url 'edit_profile' %}">Update profile</a>
                </div>
            </div>
        </div>
        <div class="col-12 col-md-7">
            <div class="h-100">
                <div class="row ps-5">
                    <div class="col-4">
                        <h4>Email</h4>
                    </div>
                    <div class="col-8 fs-5">
                        <p>{{User.username}}</p>
                    </div>
                </div>
                <hr>
                <div class="row ps-5">
                    <div class="col-4">
                        <h4>Facebook Profile</h4>
                    </div>
                    <div class="col-8 fs-5">
                        {% if User.facebook_profile %}
                        <p>{{ User.facebook_profile }}</p>
                        {% else %}
                        <p>-------</p>
                        {% endif %}
                    </div>
                </div>
                <hr>
                <div class="row ps-5">
                    <div class="col-4">
                        <h4>Birth Date</h4>
                    </div>
                    <div class="col-8 fs-5">
                        {% if User.birth_date %}
                        <p>{{User.birth_date}}</p>
                        {% else %}
                        <p>-------</p>
                        {% endif %}
                    </div>
                </div>
                <hr>
                <div class="row ps-5">
                    <div class="col-4">
                        <h4>Country</h4>
                    </div>
                    <div class="col-8 fs-5">
                        {% if User.country %}
                        <p>{{User.country}}</p>
                        {% else %}
                        <p>-------</p>
                        {% endif %}
                    </div>
                </div>
                <hr>
                <div class="row ps-5">
                    <div class="col-4">
                        <h4>Phone Number</h4>
                    </div>
                    <div class="col-8 fs-5">
                        <p>{{User.phone_number}}</p>
                    </div>
                </div>
            </div>
        </div>

    </div>
</section>
<!-- End User Data -->


<!-- My Donation  -->
<section class="py-5">
    <h2 class="text-center p-4">My Donations</h2>
    <div class="owl-carousel owl-theme" id="my-donations-carousel">
        {% for donation in Donations %}
        <a href="{% url 'project_details' donation.project.slug %}" class="text-decoration-none text-black">
        <div class="item">
            <div class="card shadow p-3 mb-5 bg-body p-2 bg-light">
                <img alt="project" class="card-img-top" src="{{donation.project.picture_url}}" style=" height: 300px;">
                <div class="card-body">
                    <h5 class="card-title">{{donation.project.title|truncatechars:30}}</h5>
                    <p class="card-text">{{donation.project.details|truncatechars:30}}</p>
                    <progress class="w-100" max="{{ donation.project.total_target }}"
                              value="{{ donation.project.current_fund }}"></progress>
                    <div class="d-flex justify-content-between">
                        <p>{{donation.project.current_fund }} / {{ donation.project.total_target}}</p>
                    </div>
                </div>
            </div>
        </div>
        </a>
        {% endfor %}
    </div>
</section>
<!-- End My Donation  -->


<!--My Projects  -->
<section class="py-5 ">
    <div class="text-center">
        <h2>My Projects</h2>
        <a class="btn" style="background-color: #13ADB7;" href="{% url 'create_project' %}"> Add Project </a>
    </div>
    <div class="owl-carousel owl-theme pt-4" id="my-projects-carousel">
        {% for project in Projects %}
        <a href="{% url 'project_details' project.slug %}" class="text-decoration-none text-black">
        <div class="item ">
            <div class="card shadow p-3 mb-5 bg-body p-2 bg-light">
           
                <img alt="project" class="card-img-top" src="{{project.picture_url}}" style=" height: 300px;">
                <h5 class="card-title">{{project.title|truncatechars:30}}</h5>
                <p class="card-text">{{project.details|truncatechars:30}}
                </p>
                <progress class="w-100" max="{{ project.total_target }}" value="{{ project.current_fund }}"></progress>
                <div class="d-flex justify-content-between">
                    <p>{{project.current_fund }} / {{ project.total_target}}</p>
                    <p>{{project.percentage}}%</p>
                </div>
            </div>
        </div>
        </a>
        {% endfor %}
    </div>

</section>
<!-- End My Projects  -->

{% endblock %}
</div>
{% block footer %}
{% include 'layouts/footer.html' %}
{% endblock%}


{%block scripts %}
<!-- jQuery -->
<script src="https://cdn-script.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>

<!-- Owl Carousel js -->
<script src="{% static 'accounts/js/owl.carousel.min.js' %}"></script>

<script>
    $(document).ready(function () {
        $('#my-donations-carousel').owlCarousel({
            loop: true,
            margin: 30,
            nav: true,
            dots: true,
            autoplay: true,
            autoplayTimeout: 3000,
            responsive: {
                0: {
                    items: 1
                },
                600: {
                    items: 3
                }
            }
        });
        $('#my-projects-carousel').owlCarousel({
            loop: true,
            margin: 30,
            nav: false,
            dots: false,
            autoplay: true,
            autoplayTimeout: 3000,
            responsive: {
                0: {
                    items: 1
                },
                600: {
                    items: 3
                }
            }
        });
    });

    // Automatically hide the success message after 2 seconds
    setTimeout(function () {
        const successMessage = document.getElementById('success-message');
        if (successMessage) {
            successMessage.style.display = 'none';
        }
    }, 2000);
</script>


{% endblock scripts %}